package org.gcube.portlets.widgets.workspacesharingwidget.client.rpc;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface WorkspaceSharingServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.gcube.portlets.widgets.workspacesharingwidget.client.rpc.WorkspaceSharingService
     */
    void greetServer( java.lang.String name, AsyncCallback<java.lang.String> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static WorkspaceSharingServiceAsync instance;

        public static final WorkspaceSharingServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (WorkspaceSharingServiceAsync) GWT.create( WorkspaceSharingService.class );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
